using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls.UI;
using Telerik.WinControls;

namespace RadGridViewCellFormatting
{
   public partial class Form1 : Form
   {
        public Form1()
        {
            InitializeComponent();

            BindingList<MyObj> list = new BindingList<MyObj>();
            for(int i = 0; i < 30; i++)
            {
                 list.Add(new MyObj("Peter"));
                 list.Add(new MyObj("George"));
                 list.Add(new MyObj("John"));
            }

            this.radGridView1.DataSource = list;

            GridViewCommandColumn applyCol = new GridViewCommandColumn();
            applyCol.FieldName = "Apply";
            this.radGridView1.Columns.Add(applyCol);

            GridViewCommandColumn removeCol = new GridViewCommandColumn();
            removeCol.FieldName = "Remove";
            this.radGridView1.Columns.Add(removeCol);

            GridViewDataColumn hiddenValueCol = new GridViewDataColumn();
            hiddenValueCol.FieldName = "ValueCol";
            hiddenValueCol.IsVisible = false;
            this.radGridView1.Columns.Add(hiddenValueCol);

            foreach (GridViewDataRowInfo row in this.radGridView1.Rows)
            {
                row.Cells[3].Value = 0;
            }

            this.radGridView1.CommandCellClick += new CommandCellClickEventHandler(radGridView1_CommandCellClick);
            this.radGridView1.CellFormatting += new CellFormattingEventHandler(radGridView1_CellFormatting);
        }

        void radGridView1_CellFormatting(object sender, CellFormattingEventArgs e)
        {
             if (((GridViewDataColumn)e.CellElement.ColumnInfo).FieldName == "Apply")
            {
                if (int.Parse(e.CellElement.RowInfo.Cells[3].Value.ToString()) == 1)
                {
                    e.CellElement.Children[0].Visibility = ElementVisibility.Hidden;
                }
                else
                {
                    e.CellElement.Children[0].Visibility = ElementVisibility.Visible;
                }
            }
            else if (((GridViewDataColumn)e.CellElement.ColumnInfo).FieldName == "Remove")
            {
                if (int.Parse(e.CellElement.RowInfo.Cells[3].Value.ToString()) == 1)
                {
                    e.CellElement.Children[0].Visibility = ElementVisibility.Visible;
                }
                else
                {
                    e.CellElement.Children[0].Visibility = ElementVisibility.Hidden;
                }
            } 
        }

        void radGridView1_CommandCellClick(object sender, EventArgs e)
        {            
            GridCommandCellElement commmandCell = sender as GridCommandCellElement;
            if (((GridViewDataColumn)commmandCell.ColumnInfo).FieldName == "Apply")
            {
                commmandCell.RowInfo.Cells[3].Value = 1;
            }
            this.radGridView1.GridElement.Update(GridUINotifyAction.StateChanged);
        }
    }

    public class MyObj
    {
        private string name;

        public MyObj(string name)
        {
            this.name = name;
        }

        public string Name
        {
            get
            {
                return name;
            }
            set
            {
                name = value;
            }
        }
    }
}